library libmsg;
//DLL d'interception de messages (avant traitement)
//Si on dtecte un message WM_KEYDOWN ou WM_KEYUP,
//vkscan et virtualkey sont modifis si la frappe
//provient du pav numrique en mode numlock dsactiv.
//
//Jean-Claude BELLAMY   2002
//
uses
 Windows,SysUtils,Messages ;
{$R *.RES}

//-----------Data Structure to be shared------------//
type
 THookData=class
           hHookMsg   : HHook;
           Instances  : Cardinal;
           end;
const
//--------Constants ---------------------//
 MemShareName='Hook_KNumLock';
 VK_NUMPAD0 = $60;
 VK_NUMPAD1 = $61;
 VK_NUMPAD2 = $62;
 VK_NUMPAD3 = $63;
 VK_NUMPAD4 = $64;
 VK_NUMPAD5 = $65;
 VK_NUMPAD6 = $66;
 VK_NUMPAD7 = $67;
 VK_NUMPAD8 = $68;
 VK_NUMPAD9 = $69;
//------------------Variables-------------------------//
var
 MemShare : Cardinal;    //Memory-Mapped File handle
 MyData   : THookData;   //Library-Shared Data

//-----------------Keyboard Hook Callback---------------//
function MsgHook(hCode,wParam:LongInt;lParam:LongInt):Longint;stdcall;
var
 p : pMsg;
 oldVK,newVK : word;
 oldSC,newSC : word;
 extendkey : boolean;
 modif : boolean;
begin
if (hCode>=0) then
  	begin
   p:=pmsg(lparam);
   if (p^.message=wm_KeyDown) or (p^.message=wm_KeyUp) then
  	   begin
      oldVK:=p^.wparam;
		oldSC:=hiword(p^.lparam) and $00FF;
		extendkey:=((hiword(p^.lparam) and $0100)=$0100);
      if not extendkey then
		   begin
		   modif:=true;
			case oldVK of
   			VK_HOME   : newVK:=VK_NUMPAD7;
		      VK_UP     : newVK:=VK_NUMPAD8;
     			VK_PRIOR  : newVK:=VK_NUMPAD9;
	   	   VK_LEFT   : newVK:=VK_NUMPAD4;
     			VK_CLEAR	 : newVK:=VK_NUMPAD5;
		      VK_RIGHT	 : newVK:=VK_NUMPAD6;
  	   		VK_END	 : newVK:=VK_NUMPAD1;
		      VK_DOWN	 : newVK:=VK_NUMPAD2;
	   	   VK_NEXT	 : newVK:=VK_NUMPAD3;
     			VK_INSERT : newVK:=VK_NUMPAD0;
		      VK_DELETE : newVK:=VK_DECIMAL;
  	   		else modif:=false;
     	      end;
			if modif then
         	begin
  	         p^.wparam:=newVK;
     	      newSC:=MapVirtualKey(newVK,0);
        	   p^.lParam:=p^.lParam and $FF00FFFF or (newSC shl 16);
           	end;
	   	end;
  	   end;
   end;
Result:=CallNextHookEx(MyData.hHookMsg,hCode,wParam,lParam);
end;

//-------------Function to set hook----------------//
function HookMSG:LongInt;stdcall;
var
 CodeRet : HHook;
begin
CodeRet:=SetWindowsHookEx(WH_GETMESSAGE,@MsgHook,HInstance,0);
MyData.hHookMsg:=CodeRet;
HookMSG:=CodeRet;
end;

//------------------Function to remove Hook----------------//
function UnHookMSG:Boolean;stdcall;
begin
Result:=True;
if MyData.hHookMsg<>0 then
	begin
   Result:=UnhookWindowsHookEx(MyData.hHookMsg);
	if Result then MyData.hHookMsg:=0;
  	end;
end;

//-----------Function to determine, whether we are already hooked-----------//
function IsHookedMSG:Boolean;stdcall;
begin
IsHookedMSG:=(MyData.hHookMsg<>0);
end;

//-----------------DllEntryPoint----------//
procedure LibraryProc(Reason: Integer);
var
 FirstInstance:Boolean;
begin
case Reason of
   DLL_PROCESS_DETACH : begin
   						   MyData.Instances:=MyData.Instances-1;
							   if (MyData.Instances=0) then
							      begin
   								UnmapViewOfFile(MyData);
   	     						CloseHandle(MemShare);
                           end;
                        end;
   DLL_PROCESS_ATTACH : begin
   							MemShare:=OpenFileMapping(FILE_MAP_ALL_ACCESS,False,MemShareName);
								FirstInstance:=(MemShare=0);
                        if MemShare=0 then MemShare:=CreateFileMapping($FFFFFFFF,nil,PAGE_READWRITE,0,
                                  THookData.InstanceSize,MemShareName);
								if MemShare<>0 then
								   begin
                        	MyData:=MapViewOfFile(MemShare,FILE_MAP_WRITE,0,0,0);
                           if Firstinstance then
                           	begin
	                        	MyData.hHookMsg:=0;
                              MyData.Instances:=0;
                              end;
									MyData.Instances:=MyData.Instances+1;
                           end;
                        end;
   end;
end;

//-----------------Exports...-----------------//
exports
   HookMSG          ,
   UnHookMSG        ,
   IsHookedMSG
   ;
//--------------------------------------------------------//
begin
DllProc:=@LibraryProc;
LibraryProc(DLL_PROCESS_ATTACH);
end.



